<?php
/* Drop code here that should execute prior to call the page (i.e. setup DB stuff) */

/* ############## VERSION ############## */
$GBL['VERSION'] = "1.7.8";	// This current version
$GBL['SCHEMA'] = "4";		// Database schema expected
$GBL['AGENT'] = "2.0.0";	// Required Agent expected
/* ##################################### */

include_once("FMK_lib/func_ChkAuth.php");
/*** Include logging functions ***/
include_once("FMK_lib/func_Log.php");
/*** Include PEAR DB wrapper functions ***/
require_once( "DB.php" );


function limitPrint($text,$limit=50)
	{
	$len = strlen($text);
	if($len > $limit)
		{
		$text = substr($text, 0, $limit) . "...";
		}	
	return($text);
	}



/*** Initialize Global settings ***/
list($GBL['DOC_ROOT'],$crap) = explode('index.php',$_SERVER['SCRIPT_FILENAME'],2);
//print "<P>-".$GBL['DOC_ROOT']."</p>";
$GBL['conf_file'] = $GBL['DOC_ROOT'] . "conf/conf.php";
if ( file_exists( $GBL['conf_file'] ) )
	{
	$GBL['conf_file_exists'] = true;
	include_once($GBL['conf_file']);
	$GBL['trashcan'] = $GBL['tmpdir'] . "/snortsms.recycle.bin";
	$GBL['tmpdir'] .= "/.snortsms";	
	}
else
	{
	$GBL['conf_file_exists'] = false;
	/* Load default vaules */
	include_once("conf/act_init_vars.php");
	}


/* Null Event session vars if not in the Event application zone */
if( $obj_FMK->currentZone() != "events" ) 
	{
	$_SESSION['query_cache'] = NULL;
	}
	
/** Define Access Control Levels ACL's **/
$FMK_acl["revoked"] 	= 0;
$FMK_acl["loggedin"] 	= 1;
$FMK_acl["user"] 		= 1;
$FMK_acl["puser"] 		= 5;
$FMK_acl["admin"] 		= 10;
	
$curr_auth = $_SESSION["auth"];
		
/*** Open Persistant Database Conection to the SnortSMS DB ***/
$GBL["dbdsn"] = $GBL["dbtype"] . "://" . $GBL["dbuser"] . ":" . $GBL["dbpasswd"] . "@" . $GBL["dbhost"] . "/" . $GBL["dbname"];	// DSN String
$db = DB::connect($GBL["dbdsn"],true);
if (DB::isError($db))
	{
	$error = $db->getMessage();
	?>
	<CENTER>
	<BR>
	<table bgcolor="Red"><tr><td>
	<table bgcolor ="White">
	<tr><td>
	<h3 style="color:Red;">Error: Cannot connect to the SnortSMS database.</h3>
	<P><B>Please verify the DB <i>name, type, IP, UserID, and Password</i> are correct in <a href="index.php?fmk=conf.main">'Global Setting'</a> menu, and that the database exists.</B></P>
	<P>Error code: <?=$error?></P>
	</td></tr>
	</table>
	</td></tr></table>
	</CENTER>
	<?
	LogEvent("Error: cannot connect to SnortSMS database: $error");
	}	









?>
