<?
/***
// Redirects to login page if not yet logged in.
// Redirects to "not authorized" page page if access level is too low.
***/
function ChkAuth ($req_auth)
	{
	global $FMK_acl;
	
	// !! If the config file doesn't exist, we bypass all authentication checks.
	if($GBL['conf_file_exists'] === false)
		{
		return;
		}
	
	$curr_auth = $_SESSION["auth"];
	
	if( $curr_auth < $FMK_acl["loggedin"] )
		{
		// Not logged-in
		FMK_Location("index.php?fmk=users.login");
		exit(1);
		}
	elseif( $curr_auth < $req_auth )
		{
		// Not enough priviledges
		FMK_Location("index.php?fmk=users.unauth");
		exit(1);
		}
		
	// ELSE we pass-thru
	return;

	}
?>