<?
/***************************************************************************
 *   Copyright (C) 2005 by J Randolph Smith                                *
 *   snortsms@servangle.net                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

 
function GenBarnConf($sensorid,&$barn_conf,&$barn_conf_MD5)
	{
	global $db, $GBL;
	
	/* Get sensor info */
	$sql = "select * FROM TBL_SENSORS WHERE id =" . $sensorid;
	$rsSensor = $db->query($sql); if (DB::isError($rsSensor)) { die ($rsSensor->getdebugInfo());}
	$row=$rsSensor->fetchRow(DB_FETCHMODE_ASSOC);
	$temp_sensorname = $row['name'];
	$temp_sensorip = $row['ip'];
	$temp_sensorport = $row['port'];
	$temp_sensoruserid = $row['userid'];
	$temp_sensorpasswd = $row['passwd'];
	$temp_sensorprotocol = $row['protocol'];
	$temp_sensorsigmsg = $row['sigmsg'];
	$temp_snort_ctrl = $row['snort_ctrl'];
	
	if($temp_snort_ctrl == "")
		{
		Stop (" You have not selected a 'Snort Control Profile' for this sensor");
		}	
	
	/* Get the snortcontrol settings */
	$sql = "SELECT * FROM TBL_SNORT_CTRL WHERE id = " . $temp_snort_ctrl;
	$rsSnortCTRL = $db->query($sql); if (DB::isError($rsSnortCTRL)) { die ($rsSnortCTRL->getdebugInfo());}
	if ($row=$rsSnortCTRL->fetchRow(DB_FETCHMODE_ASSOC)) 
		{
		$temp_interface = $row['interface'];
		$temp_conf_path = $row['conf_path'];
		$rsSnortCTRL->free();
		}
	
	/* Get Barnyard conf data */
	$sql = "SELECT b.* FROM TBL_ASSIGNMENTS as a, TBL_BARNYARD as b WHERE a.type = 'B' AND b.id = a.itemid AND a.sensorid =" . $sensorid . " ORDER BY b.title";
	$rsBarns = $db->query($sql); if (DB::isError($rsBarns)) { die ($rsBarns->getdebugInfo());}
	
	/* Get todays date */
	$barn_conf_date = date("r");
	
	/*** Lets generate the conf file ***/	
	$barn_conf =	"#-------------------------------------------------------------------------------\n".
					"# Barnyard Configuration file for < ".
					$temp_sensorname." >\n".
					"# Generated by SnortSMS < http://sourceforge.net/projects/snortSMS/ >\n".
					"# File: SMS_barnyard." . $temp_interface . ".conf\n".
					"#-------------------------------------------------------------------------------\n";
	
		
	$barn_conf .= "config hostname: " . $temp_sensorname . "\n\n";
	
	$barn_conf .= "config interface: " . $temp_interface . "\n\n";
	
	
	while($row=$rsBarns->fetchRow(DB_FETCHMODE_ASSOC))
		{	
		$barn_conf .= $row['contents'] . "\n";	
		}
	
	/*** Get MD5 Checksum ***/
	$barn_conf_MD5 = md5($barn_conf);
	

	
	}
	
	
	
	
	
?>
