<?
/***************************************************************************
 *   Copyright (C) 2005 by J Randolph Smith                                *
 *   snortsms@servangle.net                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

 
include_once("obj_Rule.php");



function Gen_sid_msg($sensorid)
	{

	global $db;

	/*** Get todays date ***/	$date = date("r");		/* Get sensor info */	$sql = "SELECT * FROM TBL_SENSORS WHERE id =" . $sensorid;	$rsSensor = $db->query($sql); if (DB::isError($rsSensor)) { die ($rsSensor->getdebugInfo());}	$row=$rsSensor->fetchRow(DB_FETCHMODE_ASSOC);	$temp_sensorname = $row['name'];
	
	/* Get the rule policies */
	$sql = "SELECT t.* FROM TBL_ASSIGNMENTS as a, TBL_POLICIES as t WHERE a.type = 'T' AND t.id = a.itemid AND a.sensorid =" . $sensorid;
	$rsPols = $db->query($sql); if (DB::isError($rsPols)) { die ($rsPols->getdebugInfo());}
	
	/* Incase more than one policy is assign to a sensor */
	$where_policies = "(1 = 2"; /* meant to do this */
	while($row=$rsPols->fetchRow(DB_FETCHMODE_ASSOC)) 
		{
		$where_policies .= " OR p.policyid = " . $row['id'];
		}
	$where_policies .= ")";
	
	/* Get the rules */
	$sql = "SELECT DISTINCT r.rule, r.cata FROM TBL_RULES as r, TBL_POLICIES_RULES as p WHERE p.ruleid = r.sid AND " .$where_policies. " ORDER BY r.sid";
	$rsRules = $db->query($sql); if (DB::isError($rsRules)) { die ($rsRules->getdebugInfo());}

	$output = "";
	$output = "#-------------------------------------------------------------------------------\n".
	$output .= "# SID -> MSG map Configuration file for < ".$temp_sensorname." >\n";
	$output .= "# Generated by SnortSMS < http://sourceforge.net/projects/snortSMS/ >\n";
	$output .= "# Format: SID || MSG || Optional References || Optional References ...\n";
	$output .= "# ".chr(36)."Id: SMS_sid_msg.map".chr(36)."\n";
	$output .= "#-------------------------------------------------------------------------------\n\n";
	
	while($row=$rsRules->fetchRow(DB_FETCHMODE_ASSOC)) 
		{
		$Rule = New Rule();		
		$Rule->Parse($row["rule"]);
		
		$sid = $Rule->getOption("metadata","sid");		
		$msg = $Rule->getOption("metadata","msg");
		$msg = preg_replace("/\"/", "", $msg);
		$references = $Rule->getOption("metadata","reference");
		
		$refs = "";
		if(is_array($references))
			{
			foreach($references as $ref)
				{
				$refs .= " || $ref";
				}
			}

		if( ($sid != "") && ($msg != "") )
			{
			$output .= "$sid || $msg" . $refs . "\n";
			}
			
		}
	
	return $output;
	}

	



