<?
/***************************************************************************
 *   Copyright (C) 2005 by J Randolph Smith                                *
 *   snortsms@servangle.net                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

	
	
?>


<table border="1">
<tr><th>Feature</th><th>Description</th><th>Status</th><th>Comments</th></tr>


<?
$check_name = "CURL";
$check_desc = "Non-interactive tool to get files from FTP, GOPHER, HTTP(S)";
if (file_exists($GBL['curl'])) 
	{	
	$check_status = "Found\n";
	$check_color = "Green";
	$check_comments = "";
	exec($GBL['curl'] . " -V",$output);	
	foreach($output as $line) { $check_comments .= $line . "<BR>"; }	
	}
else
	{
	$check_status = "Not Found";
	$check_color = "Red";
	$check_comments = "Please check that you have curl installed and the SnortSMS settings path is correct.";
	}
?>
<tr><td align="center"><?=$check_name?></td><td><?=$check_desc?></td><td align="center" style="color:<?=$check_color?>;font-weight:bold;"><?=$check_status?></td><td><?=$check_comments?></td></tr>



<?
$check_name = "tar";
$check_desc = "Creates and manipulates streaming archive files";
if (file_exists($GBL['tar'])) 
	{	
	$check_status = "Found\n";
	$check_color = "Green";
	$check_comments = "&nbsp";
	}
else
	{
	$check_status = "Not Found";
	$check_color = "Yellow";
	$check_comments = "";
	}
?>
<tr><td align="center"><?=$check_name?></td><td><?=$check_desc?></td><td align="center" style="color:<?=$check_color?>;font-weight:bold;"><?=$check_status?></td><td><?=$check_comments?></td></tr>


<?
$check_name = "MySQL";
$check_desc = "Multithreaded SQL database (client)";
if (function_exists("mysql_stat")) 
	{	
	$check_status = "Found\n";
	$check_color = "Green";
	$check_comments = "PHP supports MySQL database servers.";
	}
else
	{
	$check_status = "Not Found";
	$check_color = "Yellow";
	$check_comments = "PHP is not able to communicate with MySQL type database servers.";
	}
?>
<tr><td align="center"><?=$check_name?></td><td><?=$check_desc?></td><td align="center" style="color:<?=$check_color?>;font-weight:bold;"><?=$check_status?></td><td><?=$check_comments?></td></tr>



<?
$check_name = "pear-DB";
$check_desc = "PEAR Database Abstraction Layer";
if (method_exists($db,'getMessage')) 
	{	
	$check_status = "Found\n";
	$check_color = "Green";
	$check_comments = "PHP supports MySQL database servers.";
	}
else
	{
	$check_status = "Not Found";
	$check_color = "Yellow";
	$check_comments = "PHP is not able to communicate with MySQL type database servers.";
	}
?>
<tr><td align="center"><?=$check_name?></td><td><?=$check_desc?></td><td align="center" style="color:<?=$check_color?>;font-weight:bold;"><?=$check_status?></td><td><?=$check_comments?></td></tr>


</table>