<?php


/********************************************
********* Database: The PEAR way ************
********************************************/
/*** Include PEAR DB wrapper functions ***/
include_once( "DB.php" );

/*** Open Persistant Database Conection ***/
$GBL["dbdsn_snort"] = $GBL["dbtype_snort"] . "://" . $GBL["dbuser_snort"] . ":" . $GBL["dbpasswd_snort"] . "@" . $GBL["dbhost_snort"] . "/" . $GBL["dbname_snort"];

$db_sa = DB::connect($GBL["dbdsn_snort"],true);
if (DB::isError($db_sa))
	{
	$error = $db_sa->getMessage();
	?>
	<CENTER>
	<BR>
	<table bgcolor="Red"><tr><td>
	<table bgcolor ="White">
	<tr><td>
	<h3 style="color:Red;">Error: Cannot connect to the Snort Alert database [<?=$GBL["dbname_snort"]?>].</h3>
	<P><B>Please verify the DB <i>name, type, IP, UserID, and Password</i> are correct in <a href="index.php?fmk=conf.main">'Global Setting'</a> menu, and that the database exists.</B></P>
	<P>Error code: <?=$error?></P>
	</td></tr>
	</table>
	</td></tr></table>
	</CENTER>
	<?
	LogEvent("Error: cannot connect to Snort Alert database: $error");
	exit(1);
	}




function insertCache(&$rsSigs_cache)
	{
	global $db;	

	$qid = $_SESSION['cache']['count'];	// each cache gets it's own cache dataset.
	$usersessid = $_SESSION['cache']['token'];

	//$rsSigs_cache = $rsSigs;
	$qdate = date("Y-m-d G:i:s");
	$past_time = time() - (3600 * 1); // one hour ago
	$past_qdate = date("Y-m-d G:i:s",$past_time);

	/* Cache Garbage collection: Clear *everybody's* cache older than 1 hour.  */
	$sql = "DELETE FROM TBL_RESULTS_CACHE where qdate <= '".$past_qdate."'   ";
	$result = $db->query($sql); if (DB::isError($result)) { Stop ($result->getdebugInfo());}

	/* Since the resultset could be very large, let's use "batch" sql inserts (multiple if needed) */
	if( count($rsSigs_cache) >= 1) 
		{
		/* Prepare SQL insert batches */
		/* i.e. insert into table_blah (fields) values (data),(data),(data) etc ... */
		$i=0; // track max 'value' clauses per batch
		$id=0; // track query result count
		$qid++; // track cache dataset id
		$sql_inserts = array();
		$sql_inserts_cnt = 0;	// track number of batches
		$sql_inserts[$sql_inserts_cnt] = "";
		foreach($rsSigs_cache as $row )
			{
			$comma = ( $i > 0 ? "," : " " );
			$sql_inserts[$sql_inserts_cnt] .= $comma . "\n('".$usersessid."',".$qid.",".$id.",'".$qdate."',".$row['sid'].",".$row['cid'].")";
			$i++; $id++;
			/* If needed - we'll start a new batch statement as to not break mysql's input buffer */
			if( ($i % 1000) == 0 )
				{
				$i=0;
				$sql_inserts_cnt++;
				$sql_inserts[$sql_inserts_cnt] = "";
				}
			}
		/* Store cache results : execute each insert batch created */
		foreach($sql_inserts as $values)
			{
			$sql = "INSERT INTO TBL_RESULTS_CACHE (sessid,qid,id,qdate,sid,cid) values" . $values;
			$result = $db->query($sql); if (DB::isError($result)) { Stop ($result->getdebugInfo());}
			}
		//$cache_set = 1;

		$_REQUEST['cache_set'] 		= $qid; // Set the Cache control resultset
		$_SESSION['cache']['count'] = $qid; // Store the last Cache control number

		return $qid;
		}

	return 0;
	}








?>