<?php
include_once("FMK_lib/func_IsIP.php");
$urlcriteria = "";
$errors = "";
$phpsessid = $_REQUEST['PHPSESSID'];
// Cache control
$cache_set = (isset($_REQUEST['cache_set']) ? $_REQUEST['cache_set'] : "0" );



//print"<PRE>\n";
//print_r($_REQUEST);
//print"</PRE>\n";


/*** Is the Query is not yet cached, lets cache it ***/
if($cache_set == 0 )
	{
	/*** Add timestamps to where clause ***/
	$sql_window = "";
	if($_REQUEST['sd'] != "")
		{
		$temp_sd = $_REQUEST['sd'];
		$temp_st = ($_REQUEST['st'] == "" ? "00:00:00" : $_REQUEST['st'] );
		$sql_window .= " AND e.timestamp >= '" . $temp_sd . " " . $temp_st . "'";
		$_SESSION['search']['sd'] = $temp_sd;
		$_SESSION['search']['st'] = $temp_st;
		}
	if($_REQUEST['ed'] != "")
		{
		$temp_ed = $_REQUEST['ed'];
		$temp_et = ($_REQUEST['et'] == "" ? "23:59:59" : $_REQUEST['et'] );	
		$sql_window .= " AND e.timestamp <= '" . $temp_ed . " " . $temp_et . "'";
		$_SESSION['search']['ed'] = $temp_ed;
		$_SESSION['search']['et'] = $temp_et;
		}

	$sql_sensors = "";
	if( is_array($_REQUEST['FRM_sensors']) )
		{
		$sql_sensors = " AND ( ";
		$sensor_all = false;
		foreach($_REQUEST['FRM_sensors'] as $temp_sensor_id)
			{
			if( (int)$temp_sensor_id < 1)	// Check if 'ALL' was selected
				{
				$sensor_all = true;
				}
			$sql_sensors .= " e.sid = $temp_sensor_id OR";	
			}
		$sql_sensors = rtrim($sql_sensors,"OR");	
		$sql_sensors .= " )";
		
		if($sensor_all) 
			{ 
			$sql_sensors = ""; 
			$_SESSION['search']['sensors'] = NULL;
			}	// If "all" sensors is choosen, then cancel the sql clause.
		else
			{
			$_SESSION['search']['sensors'] = $_REQUEST['FRM_sensors'];
			
			}
		}
		

	/***************************** Pattern searches *****************************/
	if($_REQUEST['FRM_string'] != "")
		{
		$criteria_string = true;		
		$temp_string = $_REQUEST['FRM_string'];
		$_SESSION['search']['string'] = $temp_string;

		/* Check if payload matches */
		$len = strlen($temp_string);
		$temp_hexstring = "";
		for($i = 0; $i < $len; $i++)	/* convert string to hex-string */
			{
			$ascii = ord( substr($temp_string, $i, 1) );
			$temp_hexstring .= sprintf("%02X", $ascii);		
			}

		$sql = "SELECT e.sid, e.cid FROM data as d, event as e".
			" WHERE e.cid = d.cid AND e.sid = d.sid".
			$sql_sensors.
			$sql_window.
			" AND d.data_payload Like '%".$temp_hexstring."%'";
		
		$rsSigs = $db_sa->query($sql); if (DB::isError($rsSigs)) { die ($rsSigs->getDebugInfo());}
		
		while($row = $rsSigs->fetchRow(DB_FETCHMODE_ASSOC))
			{
			$hash = $row['sid'] . "-" . $row['cid'];
			$resultset[$hash]['string'] = true;
			}
		
		/* Check if alert name matches */
		$sql = "SELECT e.sid, e.cid FROM signature as s, event as e".
			" WHERE e.signature = s.sig_id".
			$sql_sensors.
			$sql_window.
			" AND s.sig_name Like '%".$temp_string."%'";

		$rsSigs = $db_sa->query($sql); if (DB::isError($rsSigs)) { die ($rsSigs->getDebugInfo());}
		
		while($row = $rsSigs->fetchRow(DB_FETCHMODE_ASSOC))
			{
			$hash = $row['sid'] . "-" . $row['cid'];
			$resultset[$hash]['string'] = true;
			}
		$rsSigs->free();
		}



		

	/***************************** IP searches *****************************/
	if($_REQUEST['FRM_ip'] != "")
		{
		$criteria_ip = true;
		
		$temp_ip = $_REQUEST['FRM_ip'];
		$_SESSION['search']['ip'] = $temp_ip;

		if(IsCIDR($temp_ip))
			{
			list($temp_net, $temp_mask) = explode('/', $temp_ip);
			
			$temp_mask = 32 - $temp_mask;
			$temp_longip = ip2long($temp_net);
			$sql_search = sprintf(" AND ( (i.ip_src >> %d) = (%u >> %d) OR (i.ip_dst >> %d) = (%u >> %d) )",  $temp_mask, $temp_longip, $temp_mask, $temp_mask, $temp_longip, $temp_mask ); // Must use sprintf to handle unsigned long int.
			}
		elseif(IsIP($temp_ip))
			{
			$ip_long = ip2long($temp_ip);
			$sql_search = sprintf(" AND ( i.ip_src = %u OR i.ip_dst = %u )", $ip_long, $ip_long);
			}
		else
			{
			$errors .= "<BR>Invalid IP or CIDR notation\n";		
			}

		$sql = "SELECT e.sid, e.cid FROM iphdr as i, event as e".
			" WHERE e.cid = i.cid AND e.sid = i.sid".
			$sql_window.
			$sql_search;
			
		$rsSigs = $db_sa->query($sql); if (DB::isError($rsSigs)) { die ($rsSigs->getDebugInfo());}
		//$totalrows = $rsSigs->numRows();
		
		while($row = $rsSigs->fetchRow(DB_FETCHMODE_ASSOC))
			{
			$hash = $row['sid'] . "-" . $row['cid'];
			$resultset[$hash]['ip'] = true;
			}
		$rsSigs->free();
		}

		
	/***************************** Port searches *****************************/
	if($_REQUEST['FRM_port'] != "")
		{
		$criteria_port = true;

		$temp_port = $_REQUEST['FRM_port'];
		$_SESSION['search']['port'] = $temp_port;

		if(!(($temp_port >= 0) && ($temp_port <= 65535)))
			{
			$errors .= "<BR>Invalid port number or out of valid range(0-65535).\n";		
			}
		else
			{		
			$where_tcp = " AND ( t.tcp_sport = $temp_port OR t.tcp_dport = $temp_port)";
			$where_udp = " AND ( u.udp_sport = $temp_port OR u.udp_dport = $temp_port)";

			$sql_tcp = "SELECT e.sid, e.cid FROM tcphdr as t, event as e".
				" WHERE e.cid = t.cid AND e.sid = t.sid".
				$sql_sensors.
				$sql_window.
				$where_tcp;		
			$sql_udp = "SELECT e.sid, e.cid FROM udphdr as u, event as e".
				" WHERE e.cid = u.cid AND e.sid = u.sid".
				$sql_sensors.
				$sql_window.
				$where_udp;		
			$sql = "($sql_tcp) union ($sql_udp)";	

			$rsSigs = $db_sa->query($sql); if (DB::isError($rsSigs)) { die ($rsSigs->getDebugInfo());}
			//$totalrows = $rsSigs->numRows();
			
			while($row = $rsSigs->fetchRow(DB_FETCHMODE_ASSOC))
				{
				$hash = $row['sid'] . "-" . $row['cid'];
				$resultset[$hash]['port'] = true;	
				}
			$rsSigs->free();
			}
		}




	/*** Combine search results hashes into linear array ***/
	/*** Loop thru all hash results and grab only those that match all criterias ***/
	$count = 0;
	if(is_array($resultset))
		{
		foreach( $resultset as $hash=>$item )
			{
			$qual = true;
			
			if( ($criteria_ip) && (!isset($item['ip'])) ) { $qual = false; }
			if( ($criteria_port) && (!isset($item['port'])) ) { $qual = false; }
			if( ($criteria_string) && (!isset($item['string'])) ) { $qual = false; }
			
			if($qual)	/* Add to final results array */
				{
				//print "<BR>hash = $hash\n";
				list($sid,$cid) = explode("-",$hash);
				$results[$count]['sid'] = $sid;
				$results[$count]['cid'] = $cid;
				$count++;		
				} 
			}

		}
	/*** Cache the Search Results ***/
	$cache_set = insertCache( $results );
//print"<P>SQL=$sql\n";

	}

//exit;
/* Redirect in Handler */
?>
