<p align="center"><span class="heading">Add/Edit Rule</span></p>
<p>Use this form to add individule rules to the SnortSMS library. If you have multiple rules to add at one time, please use one of the 'import' methods.</p>


<p><span class="label">Category:</span><BR>
Select from a list of existing categories that you want the new rule to join, -or- choose 'New Category'.</p>

<p><span class="label">New Category:</span><BR>
If you would like to create a new category, enter it here.</p>

<p>Tip: When editing a rule, changing a rule's category will 'move' the rule to that category.</p>

<p><span class="label">SID Series:</span> (new rules only)<BR>
SnortSMS tries to automatically assign signature id numbers if you do not supply one in your rule definition. This helps SnortSMS focus on a specific range if disired.</p>

<p>Note: You cannot change an existing rule's SID. To do this, you should 1st delete the current rule, the re-add it under the new SID.</p>


<p><span class="label">Current Definition:</span><BR>
This shows the current rule that is in the system (if in edit mode). Click in this area to interactively display the changes you made in the edit box below.</p>


<p><span class="label">Edit Definition:</span><BR>
Cut/paste or type your rule definition here. Although the text might word-wrap, enter only one line with no line breaks (carraige returns).</p>

<p><span class="label">Notes:</span> (optional)<BR>
Feel free to enter any notes or comments about the rule that might be useful. This is informational only.</p>

<p align="center"><span class="heading">- FAQ -</span></p>

<p><span class="heading">Q:</span> <u>Why doesn't SnortSMS have an elaborate Add/Edit form</u>?<br>
<span class="heading">A:</span> 1) Simplicity: We wanted to keep the interface simple and did not want to subject users to a confusing input form design that they would have to learn. 2) Rule parsing scalability: SnortSMS uses Regular Expressions to parse and proccess rules. We didn't want to 'hard code' the parsing engine. 3) We're lazy.</p>

<p><span class="heading">Q:</span> <u>Does SnortSMS check my rules for syntax errors</u>?<br>
<span class="heading">A:</span> Yes and no. It can not determine spelling errors if you fat-finger a directive name, but because SnortSMS uses a RegEx parsing engine, it can find major syntax errors which break the rule structure (i.e. missing or extra header fields and/or missing directive delimiters).</p>
