<p align="center"><span class="heading">Barnyard Daemon Profiles</span></p>
<p>Optional. If you use Barnyard to propagate Snort alerts to a central database, a profile tells the SnortSMS remote agent on the sensor how to start and stop the Barnyard daemon.</p>

<p><B>Title :</B><BR>
Name of the profile. Any friendly name of your choice.</p>

<p><B>[ -d {dir} ] :</B><BR>
The directory where the snort is saving the unified binary logs. (Enter the directory only, no trailing slash)</p>

<p><B>[ -b {base} ] :</B><BR>
The base name of the unified snort log file. This is the same name you specified in the snort output plugin configuration.</p>

<p><B>[ -w {file} ] :</B><BR>
The file that you want barnyard to use as the bookmark file (the waldo file). (Enter full path and file name)</p>

<p><B>[ -X {file} ] :</B><BR>
The PID file. This will allow SnortSMS to track if Barnyard is running or not.</p>

<p align="center"><span class="heading">- FAQ -</span></p>
<p><span class="heading">Q:</span> <u>I have one sensor with multiple network interfaces to monitor</u>.<br>
<span class="heading">A:</span> No problem. Unlike the Snort Daemon Profiles, you will only need to define one profile because SnortSMS will automaticaly add the interface information from the coresponding Snort Profile.</p>


