<?
/***************************************************************************
 *   Copyright (C) 2005 by J Randolph Smith                                *
 *   snortsms@servangle.net                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

include_once("FMK_lib/func_DrawRepHeader.php");

DrawRepHeader("Rules");

include_once("FMK_lib/func_Rules.php");
$rule = New Rule();



$row = $rsRule->fetchRow(DB_FETCHMODE_ASSOC);
$temp_sid = $row['sid'];
$temp_cat = $row['cata'];
$temp_notes = preg_replace("/[\r\n]/","<BR>",$row['notes']);
/*** Load rule into object ***/
$rule->Parse($row['rule']);
$temp_rule = $rule->GenRule();
$temp_rev = $rule->getOption("metadata","rev");
$temp_msg = $rule->getOption("metadata","msg");
$temp_title = "Rule Details";


$payload_lines=htmlspecialchars($rule->GetPayloadLines());
$payload_lines=preg_replace("/\n/","<BR>",$payload_lines );

$nopayload_lines=htmlspecialchars($rule->GetNonPayloadLines());
$nopayload_lines=preg_replace("/\n/","<BR>",$nopayload_lines );

$postdetect_lines=htmlspecialchars($rule->GetPostDetectLines());
$postdetect_lines=preg_replace("/\n/","<BR>",$postdetect_lines );

$metadata_lines=htmlspecialchars($rule->GetMetaDataLines());
$metadata_lines=preg_replace("/\n/","<BR>",$metadata_lines );
	
$temp_menulink = "<a href=\"index.php?fmk=rules.edit&FRM_sid=".$temp_sid."&FRM_cat=".$temp_cat."\" title=\"Edit Rule\"><img src=\"images/note-1.gif\" border=\"0\"></a>&nbsp;&nbsp;&nbsp;<a href=\"index.php?fmk=rules.audit&FRM_sid=".$temp_sid."\" title=\"Rule Audit Trail\"><img src=\"images/table_multiple.png\" border=\"0\"></a>";
?>

<CENTER>

<table border="0" class="bg1" cellspacing="1" cellpadding="1">
<tr class="heading2" align="center">
<td><?=$temp_title?></TD>
</TR>
<tr><td>

<table border="0" cellspacing="4" class="bg2">
<tr>
<td><?=$temp_menulink?></td>
<td align="right" valign="top">
&nbsp;
</td>
</tr>

<tr>
<td>

	<table border="0" class="bg2">
	<tr>
	<td class="label" valign="top" nowrap>Title:</td><td class="bg4"><?=$temp_msg?></td>
	</tr>
	<tr>
	<td class="label" valign="top">Catagory:</td><td class="bg4"><?=$temp_cat?></td>
	</tr>
	<tr>
	<td class="label" valign="top">SID:</td><td class="bg4"><?=$temp_sid?></td>
	</tr>
	<tr>
	<td class="label" valign="top">Revision:</td><td class="bg4"><?=$temp_rev?></td>
	</tr>
	<tr>
	<th colspan="3">&nbsp;</th>
	</tr>
	</table>

</td>
<td align="right" valign="top">
	<form method="post" action="index.php">
	<input type="hidden" name="fmk" value="rules.policy">
	<input type="hidden" name="FRM_sid" value="<?=$temp_sid?>">
	<span class="label">Assigned Profiles:</label>&nbsp;<BR>
	<select name="FRM_policyid[]" multiple size="3">
	<?
	$sel_none = ( $rsSelPlys_total == 0 ? "selected" : "" );
	?>
	<option value="" <?=$sel_none?>>-none-</option>
	<?
	
	foreach($policies as $id=>$policy)
		{
		$sel = ( $policy['sel'] ? "selected" : "" );
		?>
		<option value="<?=$id?>" <?=$sel?>><?=$policy['name']?></option>	
		<!-- <a href="index.php?fmk=policies.catagory&FRM_policyid=<?=$row["policyid"]?>&FRM_cat=<?=$temp_cat?>"><?=$row["name"]?></a> <BR> -->
		<?
		}
	?>
	</select><BR>
	<input type="submit" value="Apply">&nbsp;
	</form>
</td>
</tr>



<tr>
<td valign="top">


<table border="0" class="bg2">
<tr>
<th class="bg5" colspan="3">Rule Headers</th>
</tr>
<tr>
<td class="label">Alert Action:</td><td class="bg4"><?=$rule->GetHeaderItem("action")?></td>
</tr>
<tr>
<td class="label">Protocol:</td><td class="bg4"><?=$rule->GetHeaderItem("protocol")?></td>
</tr>
<tr>
<td class="label">Source IP:</td><td class="bg4"><?=$rule->GetHeaderItem("src_ip")?></td>
</tr>
<tr>
<td class="label">Source Port:</td><td class="bg4"><?=$rule->GetHeaderItem("src_port")?></td>
</tr>
<tr>
<td class="label">Flow:</td><td class="bg4"><?=$rule->GetHeaderItem("flow")?></td>
</tr>
<tr>
<td class="label">Dest IP:</td><td class="bg4"><?=$rule->GetHeaderItem("dst_ip")?></td>
</tr>
<tr>
<td class="label">Dest Port:</td><td class="bg4"><?=$rule->GetHeaderItem("dst_port")?></td>
</tr>
</table>


</td><td valign="top">


<table border="0" class="bg2">
<tr>
<th class="bg5" colspan="3">Rule Options</th>
</tr>
<tr>
<td class="label" valign="top" nowrap>Non-Payload:</td><td class="bg4"><?=$nopayload_lines?></td>
</tr>
<tr>
<td class="label" valign="top" nowrap>Payload:</td><td class="bg4"><?=$payload_lines?></td>
</tr>
<tr>
<td class="label" valign="top" nowrap>Post-Detect:</td><td class="bg4"><?=$postdetect_lines?></td>
</tr>
<tr>
<td class="label" valign="top" nowrap>Meta-Data:</td><td class="bg4"><?=$metadata_lines?></td>
</tr>

</table>





</td>
</tr>
<tr>
<th colspan="2" class="bg5">Raw Definition</th>
</tr>
<tr>
<td colspan="2" class="bg4"><?=$temp_rule?></td>
</tr>
<tr>
<tr>
<td colspan="2">&nbsp;</td>
</tr>


<tr>
<th colspan="2" class="bg5">Rule Notes</th>
</tr>
<tr>
<td colspan="2" class="bg4"><?=$temp_notes?>&nbsp;</td>
</tr>





<tr>
<td><?=$temp_menulink?></td>
<td align="right">&nbsp;</td>
</tr>
</table>




</td>
</tr>
</TABLE>


</CENTER>


<?
//$rule->ShowTree();
?>

