<?
/***************************************************************************
 *   Copyright (C) 2006 by J Randolph Smith                                *
 *   snortsms@servangle.net                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

include_once("FMK_lib/func_date.php");
 
/*** Get which tab to show ***/
$tab = (isset($_REQUEST['tab']) ? $_REQUEST['tab'] : 0 );
$temp_file = (isset($_REQUEST['response']) ? $_REQUEST['response'] : "" );



if(isset($_REQUEST['msg']))
	{
	$msg = urldecode($_REQUEST['msg']);	
	}



/*** Initialize tab array ***/
$temp_tabs[0]['name'] = "Sensor";
$temp_tabs[0]['content'] = "dsp_tab_sensor.php";

$temp_tabs[1]['name'] = "Remote Agent";
$temp_tabs[1]['content'] = "dsp_tab_agent.php";

$temp_tabs[2]['name'] = "Snort Config";
$temp_tabs[2]['content'] = "dsp_tab_snort.php";

$temp_tabs[3]['name'] = "Barnyard Config ";
$temp_tabs[3]['content'] = "dsp_tab_barn.php";

$temp_tabs[4]['name'] = "Status ";
$temp_tabs[4]['content'] = "dsp_tab_status.php";



if($temp_button == "Save")
	{
	$temp_sensor_combo = "<i>&lt; New Sensor &gt;</i>";	
	}
else
	{		
	/*** Draw the Sensor dropdown box ***/
	$temp_sensor_combo = "<SELECT name=\"FRM_sensorid\"  onchange=\"this.form.submit();\">\n";
	while ($row = $rsSensors->fetchRow(DB_FETCHMODE_ASSOC))
		{
		$sel = ($row['id'] == $temp_sensorid  ? "selected" : "" );
		$temp_sensor_combo .= "<OPTION value=\"".$row['id']."\" ".$sel.">".$row['name']."</OPTION>\n";
		}
	$temp_sensor_combo .= "</SELECT>\n";
	}
	
	
include_once("dsp_header.php");	

	
	
	
/*** Show message if any ***/
if(isset($msg))
	{
	?>
	<CENTER>
	<BR>
	<table><tr><td>
	<table class="bg2">
	<tr><td><B><?=$msg?></B></td></tr>
	</table>
	</td></tr></table>
	</CENTER>
	<?
	}
else
	{
	?>
	<CENTER>
	<BR>
	<table><tr><td>
	<table>
	<tr><td>&nbsp;</td></tr>
	</table>
	</td></tr></table>
	</CENTER>
	<?
	}
?>


<script type="text/javascript" language="Javascript" src="java/waitdiv.js"></script>






<CENTER>



<DIV id="wait" style="display: none;">
	<TABLE border="0" width="100%" height="100%" cellpadding="4">
	<TR height="100%" align="center" valign="middle">
	<TD>
	<IMG src="images/wait.gif" width="250" height="97" border="0" alt="-Please Wait-">
	<P><B>Communicating with remote sensor ...</B></P>
	</TD>
	</TR>
	</TABLE>
</DIV>






<DIV id="main">

	<TABLE border="0" width="600" class="bg2" cellpadding="4">
	<TR>
	<TD>
	<FORM action="index.php" method="GET">
	<input type="hidden" name="fmk" value="<?=$obj_FMK->currentZone()?>.<?=$obj_FMK->currentAction()?>"> 
	<input type="hidden" name="tab" value="<?=$tab?>"> 
	<span class="heading">
	Sensor: 
	</span>
	<?=$temp_sensor_combo?>
	</FORM>
	</TD>
	<td align="right" valign="top">
	<a href="#" onclick="help('index.php?fmk=help.main&index=sensorconf')" title="help"><img src="images/gray_quest.gif" width="16" height="14" border="0"></a></td>
	</TR>
	
	
	<TR>
	<TD colspan="2">
	
	
	<table border="0" cellpadding="0" cellspacing="0">
	<tr height="20">
	<?
	
	if($temp_button == "Save")
		{
		$tab_link = "title=\"Save new sensor 1st\"";
		?>
		<td width="15"><img src="images/tab_left-1.gif" height="20" width="15" border="0"></td>
		<td BACKGROUND="images/tab_mid-1.gif" class="tab-on" title="Must save sensor"><?=$temp_tabs[0]['name']?></td>
		<td width="15"><img src="images/tab_right-1.gif" height="20" width="15" border="0"></td>
		<td width="5">&nbsp;</td>
		<?
		}
	else
		{	
		while (list($key, $value) = each($temp_tabs))
			{
			if($tab == $key)
				{ $class = "tab-on"; $tab_img = 1;}
			else
				{ $class = "tab-off"; $tab_img = 0; }
				
			$tab_link = "onclick=\"window.location.href='index.php?fmk=sensorconf.sensor&FRM_sensorid=".$temp_sensorid."&tab=".$key."'\"";
				
			?>
			<td width="15"><img src="images/tab_left-<?=$tab_img?>.gif" height="20" width="15" border="0"></td>
			<td BACKGROUND="images/tab_mid-<?=$tab_img?>.gif" class="<?=$class?>" <?=$tab_link?>><?=$value['name']?></td>
			<td width="15"><img src="images/tab_right-<?=$tab_img?>.gif" height="20" width="15" border="0"></td>
			<td width="2">&nbsp;</td>
			<?
			}
		}
	
	
	
	
	
	
	?>
	
	
	</tr>
	</table>
	
	<table border="0" width="100%" class="bg1" cellpadding="0">
	<tr>
	<td> 
	
	<table border="0" width="100%" cellpadding="2" class="bg2">
	<tr>
	<td> 
	
	<?
	/* Dynamically include the proper content for this tab */
	include($temp_tabs[$tab]['content']);
	?>
	
	</td>
	</tr>
	</table>
	
	</td>
	</tr>
	</table>
	
	
	
	
	
	
	</TD>
	</TR>
	
	
	</TABLE>



<BR><BR>


<?
/*** Show agent responses to screen (if any) ***/
if($temp_file != "")
	{
	?>
	<table border="0" cellspacing="1" class="combo1">
	<tr><th>Agent Responses</th></tr>
	<tr><td class="console">
	<PRE><?
	if( $fd = fopen($GBL['tmpdir'] . "/".$temp_file.".tmp", "r") )
		{
		while(!feof($fd))
			{
			$line = fread($fd, 4096);
			$line = htmlspecialchars($line);
			$line = preg_replace('/(ERROR)/i',"<B style=\"color:Red;\">$1</B>",$line);
			$line = preg_replace('/(WARNING)/i',"<B style=\"color:Yellow;\">$1</B>",$line);
			$line = preg_replace('/(sucessfully)/i',"<B style=\"color:Green;\">$1</B>",$line);
			$line = preg_replace('/(successful)/i',"<B style=\"color:Green;\">$1</B>",$line);
			$line = preg_replace('/\\s+(INACTIVE)/i',"<B style=\"color:Orange;\">$1</B>",$line);
			$line = preg_replace('/\\s+(ACTIVE)/i',"<B style=\"color:Cyan;\">$1</B>",$line);
			echo $line;
			// echo $line;			
			}	
		fclose($fd);
		unlink($GBL['tmpdir'] . "/".$temp_file.".tmp");
		}
	?></PRE>
	</td></tr>
	</table>
	<?
	}
?>


</DIV>

</CENTER>