<?
/***

NOTE: 
SnortSMS by default only activily checks sensor status when the monitoring page is being viewed.
If you would like sensors checked via a background job aswell, you may enable the following cron script:
SYNTAX:
{cron times} {path to PHP CLI} {path to snortsms cron script} {path to snortsms web root}
Example:
0,5,10,15,20,25,30,35,40,45,50,55 * * * * /usr/local/bin/php /usr/local/www/snortsms/monitor/cron_stats.php /usr/local/www/snortsms

***/


/** Get doc path from argument list ***/
$GBL['DOC_ROOT'] = $_SERVER['argv'][1];


chdir($GBL['DOC_ROOT'] . "/monitor");	/*** needed so relative directory includes work ***/
 
include_once($GBL['DOC_ROOT'] . "/FMK_lib/func_GenToken.php");

//print_r($_SERVER);

/*** Initialize Global settings ***/
$GBL['conf_file'] = $GBL['DOC_ROOT'] . "/conf/conf.php";
if ( file_exists( $GBL['conf_file'] ) )
	{
	include_once($GBL['conf_file']);
	}
else
	{
	/* Load default vaules */
	include_once($GBL['DOC_ROOT'] . "/conf/act_init_vars.php");
	}
	
	
	
/*** Include PEAR DB wrapper functions ***/
require_once( "DB.php" );
/*** Open Persistant Database Conection ***/
$GBL["dbdsn"] = $GBL["dbtype"] . "://" . $GBL["dbuser"] . ":" . $GBL["dbpasswd"] . "@" . $GBL["dbhost"] . "/" . $GBL["dbname"];	// DSN String
$db = DB::connect($GBL["dbdsn"],true);
if (DB::isError($db))
	{
	$error = $db->getMessage();
	print "DB connection error: " . $error . "\n";
	}
	
	
	


$response = "";




$sql = "SELECT * FROM TBL_SENSORS WHERE active = 1";
$rsSensors = $db->query($sql); if (DB::isError($rsSensors)) { die ($rsSensors->getdebugInfo());}



/*** Foreach sensor, lets open a child process via PHP CLI mode so we can query multiple sensors in parallel ***/
$count = 0;
while($row=$rsSensors->fetchRow(DB_FETCHMODE_ASSOC))
	{
	$sensors[$count] = $row['id'];
	$command = $GBL['php_path'] . " " . $GBL['DOC_ROOT'] . "/monitor/query_sensor.php " . $sensors[$count];
	
	// print "Launching: $command <BR>\n";
	$handle[$sensors[$count]] = popen($command, "r");
	$count++;
	}
	
/*** Let's read from each child process and close it ***/	
foreach($sensors as $sensorid)
	{
	while (!feof($handle[$sensorid]))
			{
			$response .= fread($handle[$sensorid], 8192);
			}
	pclose($handle[$sensorid]);
	}


	
	
	
	
//print $response;
?>
