<?
/***************************************************************************
 *   Copyright (C) 2005 by J Randolph Smith                                *
 *   snortsms@servangle.net                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


$MON_system = false;




$MON_stamp = Date_SQL_norm ("%d-%b-%y  %H:%M", $row['mon_stamp']);


/*** ######### Sensor Storage Space ############ ***/
$MON_partition = array();
$count=0;
$MON_disk_alert = 0;
$MON_disk_avail = 0;
$temp_df_lines = preg_split("/\\n/", $row['mon_df']);
foreach($temp_df_lines as $line)
	{
	if(preg_match("/(\\/dev[^\\s]+)\\s+(\\d+)\\s+(\\d+)\\s+(\\d+)\\s+([\\d]+)\\%\\s+([^\\s]+)/",$line,$matches))
		{
		$MON_disk_avail = 1;
		$MON_partition[$count]['dev'] = $matches[1];
		$MON_partition[$count]['used'] = round($matches[3] / 1024);
		$MON_partition[$count]['avail'] = round($matches[4] / 1024);
		$MON_partition[$count]['cap'] = $matches[5];
		$MON_partition[$count]['mp'] = $matches[6];
		
		if($MON_partition[$count]['cap'] >= $GBL['mon_hdd_critical'])
			{
			$MON_partition[$count]['status'] = "<img src=\"images/hdd-3.gif\" border=\"0\" alt=\"Disk capacity full\">";
			$MON_disk_alert = 3;
			}
		elseif($MON_partition[$count]['cap'] >= $GBL['mon_hdd_warning'])
			{
			$MON_partition[$count]['status'] = "<img src=\"images/hdd-2.gif\" border=\"0\" alt=\"Disk capacity low\">";
			}
		else
			{
			$MON_partition[$count]['status'] = "<img src=\"images/hdd-1.gif\" border=\"0\" alt=\"Disk capacity normal\">";
			}		
		$count++;
		}
	}

	
/*** ######### Agent Version ############ ***/
$MON_ver = "";
if($row['mon_ver'] == "")
	{
	$MON_ver_ind = "<img src=\"images/led2-0.gif\" border=\"0\" alt=\"Agent Version Matches\">";
	$MON_ver = "[unknown]";
	}
elseif($row['mon_ver'] == $GBL['AGENT'])
	{
	$MON_ver_ind = "<img src=\"images/led2-1.gif\" border=\"0\" alt=\"Agent Version Matches\">";
	$MON_ver = "ver " . $row['mon_ver'];
	}
else
	{
	$MON_ver_ind = "<img src=\"images/led2-3.gif\" border=\"0\" alt=\"Agent Version Matches\">";
	$MON_ver = "ver " . $row['mon_ver'] . " [ mismatch =&gt; ".$GBL['AGENT']." is required ]";
	}


	
/*** ######### Sensor CPU ############ ***/
$MON_la_alert = 0;
if(preg_match("/load average[s]?:\s+([\d|\.]+),\s([\d|\.]+),\s([\d|\.]+)/",$row['mon_uptime'],$matches))
	{
	$MON_la_1 = $matches[1];
	$MON_la_10 = $matches[2];
	$MON_la_15 = $matches[3];
	
	if(($MON_la_1 > $GBL['mon_la_critical']) || ($MON_la_10 > $GBL['mon_la_critical']) || ($MON_la_15 > $GBL['mon_la_critical']))
		{
		$MON_loadavg =  "<img src=\"images/led2-3.gif\" border=\"0\" alt=\"System Utilization Critical\">";
		$MON_la_alert = 3;
		}
	elseif(($MON_la_1 > $GBL['mon_la_warning']) || ($MON_la_10 > $GBL['mon_la_warning']) || ($MON_la_15 > $GBL['mon_la_warning']))
		{
		$MON_loadavg =  "<img src=\"images/led2-2.gif\" border=\"0\" alt=\"System Utilization High\">"; 
		}
	else
		{
		$MON_loadavg =  "<img src=\"images/led2-1.gif\" border=\"0\" alt=\"System Utilization Normal\">"; 
		}	
	}
else
	{
	$MON_loadavg =  "<img src=\"images/led-0.gif\" border=\"0\" alt=\"-unknown-\">";
	$MON_la_1 = $MON_la_10 = $MON_la_15 = "?";
	}



/*** ######### Snort Health ############ ***/
if($row['mon_snortproc'] > 0)
	{ $MON_snortproc =  "<img src=\"images/led2-1.gif\" border=\"0\" alt=\"Running[".$row['mon_snortproc']."]\">"; }
elseif($row['mon_snortproc'] == -1 )
	{ $MON_snortproc =  "<img src=\"images/led2-0.gif\" border=\"0\" alt=\"-unknown-\">"; }
else
	{ $MON_snortproc =  "<img src=\"images/led2-3.gif\" border=\"0\">"; }

if($row['mon_snortsync'] > 0)
	{ $MON_snortsync =  "<img src=\"images/conf-1.png\" border=\"0\" alt=\"In Sync\">"; }
elseif($row['mon_snortsync'] == -1 )
	{ $MON_snortsync =  "<img src=\"images/conf-0.png\" border=\"0\" alt=\"-unknown-\">"; }
else
	{ $MON_snortsync =  "<img src=\"images/conf-3.gif\" border=\"0\" alt=\"Stale\">"; }

/*** ######### Barnyard Health ############ ***/
if($row['mon_barnproc'] > 0)
	{ $MON_barnproc =  "<img src=\"images/led2-1.gif\" border=\"0\" alt=\"Running[".$row['mon_barnproc']."]\">"; }
elseif($row['mon_barnproc'] == -1 )
	{ $MON_barnproc =  "<img src=\"images/led2-0.gif\" border=\"0\" alt=\"-unknown-\">"; }
else
	{ $MON_barnproc =  "<img src=\"images/led2-3.gif\" border=\"0\">"; }

if($row['mon_barnsync'] > 0)
	{ $MON_barnsync =  "<img src=\"images/conf-1.png\" border=\"0\" alt=\"In Sync\">"; }
elseif($row['mon_barnsync'] == -1 )
	{ $MON_barnsync =  "<img src=\"images/conf-0.png\" border=\"0\" alt=\"-unknown-\">"; }
else
	{ $MON_barnsync =  "<img src=\"images/conf-3.gif\" border=\"0\" alt=\"Stale\">"; }
	
if($row['mon_db'] > 0)
	{ $MON_dbfeed =  "<img src=\"images/db-1.png\" border=\"0\" alt=\"Connection Active\">"; }
elseif($row['mon_db'] == -1 )
	{ $MON_dbfeed =  "<img src=\"images/db-0.png\" border=\"0\" alt=\"-unknown-\">"; }
else
	{ $MON_dbfeed =  "<img src=\"images/db-2.png\" border=\"0\" alt=\"Connection Idle\">"; }
	
	
if($row['mon_connect'] == 1)
	{ $MON_connect = "<img src=\"images/led-1.gif\" border=\"0\" alt=\"OK\">"; }
else
	{ $MON_connect = "<img src=\"images/led-3.gif\" border=\"0\" alt=\"Unable to connect\">"; }
	
	
	
	
if(($MON_disk_alert == 3) || ($MON_la_alert == 3))
	{ $MON_system = "<img src=\"images/led-2.gif\" border=\"0\" alt=\"System Alert\">"; }
elseif($row['mon_connect'] == 1)
	{ $MON_system =  "<img src=\"images/led-1.gif\" border=\"0\" alt=\" \">"; }
elseif($row['mon_connect'] == 0)
	{ $MON_system =  "<img src=\"images/led-3.gif\" border=\"0\" alt=\"Unable to connect\">"; }
else
	{ $MON_system =  "<img src=\"images/led-0.gif\" border=\"0\" alt=\"-unknown-\">"; }
	
	
//$rsSensor->free();

?>