<?
/***************************************************************************
 *   Copyright (C) 2005 by J Randolph Smith                                *
 *   snortsms@servangle.net                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

$jump = $obj_FMK->currentZone() . "." . $obj_FMK->currentAction();

$i = -1;

$i++;
$source[$i]['name'] = "Variables";
$source[$i]['zone'] = "variables";
$source[$i]['type'] = "V";
$source[$i]['table'] = "TBL_VARIABLES";
$source[$i]['selected'] = 0;
$source[$i]['total'] = 0;
$i++;
$source[$i]['name'] = "Dynamics";
$source[$i]['zone'] = "dynamics";
$source[$i]['type'] = "D";
$source[$i]['table'] = "TBL_DYNAMICS";
$source[$i]['selected'] = 0;
$source[$i]['total'] = 0;
$i++;
$source[$i]['name'] = "Preprocessors";
$source[$i]['zone'] = "preprocessors";
$source[$i]['type'] = "P";
$source[$i]['table'] = "TBL_PREPROCESSORS";
$source[$i]['selected'] = 0;
$source[$i]['total'] = 0;
$i++;
$source[$i]['name'] = "Output Plugins";
$source[$i]['zone'] = "outputs";
$source[$i]['type'] = "O";
$source[$i]['table'] = "TBL_OUTPUTS";
$source[$i]['selected'] = 0;
$source[$i]['total'] = 0;
$i++;
$source[$i]['name'] = "Config Directives";
$source[$i]['zone'] = "configs";
$source[$i]['type'] = "F";
$source[$i]['table'] = "TBL_CONFIGS";
$source[$i]['selected'] = 0;
$source[$i]['total'] = 0;
$i++;
$source[$i]['name'] = "References";
$source[$i]['zone'] = "references";
$source[$i]['type'] = "R";
$source[$i]['table'] = "TBL_REFERENCES";
$source[$i]['selected'] = 0;
$source[$i]['total'] = 0;
$i++;
$source[$i]['name'] = "Classifications";
$source[$i]['zone'] = "classifications";
$source[$i]['type'] = "C";
$source[$i]['table'] = "TBL_CLASSIFICATIONS";
$source[$i]['selected'] = 0;
$source[$i]['total'] = 0;
$i++;
$source[$i]['name'] = "Rule Types";
$source[$i]['zone'] = "ruletypes";
$source[$i]['type'] = "X";
$source[$i]['table'] = "TBL_RULE_TYPES";
$source[$i]['selected'] = 0;
$source[$i]['total'] = 0;
$i++;
$source[$i]['name'] = "Rule Profiles";
$source[$i]['zone'] = "policies";
$source[$i]['type'] = "T";
$source[$i]['table'] = "TBL_POLICIES";
$source[$i]['selected'] = 0;
$source[$i]['total'] = 0;
$i++;
$source[$i]['name'] = "Rule Thresholds";
$source[$i]['zone'] = "thresholds";
$source[$i]['type'] = "H";
$source[$i]['table'] = "TBL_THRESHOLDS";
$source[$i]['selected'] = 0;
$source[$i]['total'] = 0;
$i++;
$source[$i]['name'] = "Rule Suppression";
$source[$i]['zone'] = "suppressions";
$source[$i]['type'] = "S";
$source[$i]['table'] = "TBL_SUPPRESSIONS";
$source[$i]['selected'] = 0;
$source[$i]['total'] = 0;

for($i=0; $i < count($source); $i++)
	{	
	/*** Get statistics ***/
	$sql = "SELECT id FROM TBL_ASSIGNMENTS WHERE type = '".$source[$i]['type']."' AND sensorid = " . $temp_sensorid;
	$rsStat = $db->query($sql); if (DB::isError($rsStat)) { die ($rsStat->getdebugInfo());}
	$source[$i]['selected'] = $rsStat->numRows();
	$sql = "SELECT id FROM " . $source[$i]['table'];	
	$rsStat = $db->query($sql); if (DB::isError($rsStat)) { die ($rsStat->getdebugInfo());}
	$source[$i]['total'] = $rsStat->numRows();
	//print "<P>  ".$source[$i]['selected']."   ".$source[$i]['total']." </p>\n";
	}



	

$urlparams = "&tab=".$tab."&FRM_sensorid=".$temp_sensorid."&jump=".$jump;
?>
<FORM action="index.php?fmk=sensorconf.save" method="POST">
<INPUT type="hidden" name="FRM_sensorid" value="<?=$temp_sensorid?>">
<INPUT type="hidden" name="tab" value="<?=$tab?>">
<div align="center">


<table border="0" class="bg2" width="100%">
<tr><td colspan="4">&nbsp;</td></tr>


<tr>
<td class="label" align="right">Snort Daemon Profile:</td>
<td><?=$temp_snortctrl?>&nbsp;<a href="index.php?fmk=snortctrl.main">[Add/Edit]</a></td>
<td class="label" align="right">Push sig-msg map:</td><td><?=$temp_sigmsg?></td>
</tr>

<tr><td colspan="4">&nbsp;</td></tr>
<tr><td colspan="4">&nbsp;</td></tr>

<tr><td colspan="4">
<table border="0" class="bg2" cellspacing="0" cellpadding="4" width="100%">
<tr class="label">
<td align="center">Sub Catagory</td>
<td align="center">Selected</td>
<td>&nbsp;</td>
<td align="center">Available</td>
</tr>
<?
foreach ($source as $item)
	{
	?>
	<tr>
	<td align="right"><b><?=$item['name']?></b>&nbsp;</td>
	<td align="center"><span class="box"><?=$item['selected']?></span> <a href="index.php?fmk=<?=$item['zone']?>.select&FRM_sensorid=<?=$temp_sensorid?>" title="Select <?=$item['name']?>">[pick]</a></td>
	<td>&nbsp;</td>
	<td align="center" align="center"><?=$item['total']?></td>
	</tr>
	<?
	}
?>
<tr>
<td colspan="4">&nbsp;</td>
</tr><tr>
<td colspan="4" align="left">Snort Config File: <a href="index.php?fmk=sensorconf.gensnortconf&FRM_sensorid=<?=$temp_sensorid?>">[ Preview ]</a>&nbsp;</td>
</tr>
</table>
</td></tr>


<tr><td colspan="4" align="right">
<INPUT type="submit" name="button" value="<?=$temp_button?>">
</td></tr>

</table>
</FORM>